--       _________ __                 __
--      /   _____//  |_____________ _/  |______     ____  __ __  ______
--      \_____  \\   __\_  __ \__  \\   __\__  \   / ___\|  |  \/  ___/
--      /        \|  |  |  | \// __ \|  |  / __ \_/ /_/  >  |  /\___ \ 
--     /_______  /|__|  |__|  (____  /__| (____  /\___  /|____//____  >
--             \/                  \/          \//_____/            \/ 
--  ______________________                           ______________________
--                        T H E   W A R   B E G I N S
--         Stratagus - A free fantasy real time strategy game engine
--
--	(c) Copyright 2015 by Kyran Jackson
--
--      This program is free software; you can redistribute it and/or modify
--      it under the terms of the GNU General Public License as published by
--      the Free Software Foundation; either version 2 of the License, or
--      (at your option) any later version.
--  
--      This program is distributed in the hope that it will be useful,
--      but WITHOUT ANY WARRANTY; without even the implied warranty of
--      MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
--      GNU General Public License for more details.
--  
--      You should have received a copy of the GNU General Public License
--      along with this program; if not, write to the Free Software
--      Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
--

-- Ground Units

DefineUnitType("unit-grunt", { Name = _("Grunt"),
	Parent = "unit-goblin-spearman",
	Civilization = "wild",
	Image = {"file", "goblin/units/goblin_spearman.png", "size", {72, 72}},
	Description = _("Due to their small size, the goblin infantry soldiers use the spear as their weapon of choice, as with it they can target their enemies' vital points, relying less on their lackluster strength."),
	Animations = "animations-goblin-spearman", Icon = "icon-goblin-spearman",
	Costs = {"time", 60, "gold", 500, "lumber", 50},
	HitPoints = 50,
	BasicDamage = 6, -- reduced damage, since it has a bonus against mounted units
	Accuracy = 12,
	Evasion = 12,
	BonusAgainstMounted = 100,
	Corpse = "unit-goblin-dead-body",
	Sounds = {
		"selected", "basic-goblin-voices-selected-group",
		"acknowledge", "basic-goblin-voices-acknowledge",
		"ready", "goblin-impaler-ready",
--		"help", "basic-dwarf-voices-help",
		"dead", "basic-goblin-voices-dead",
		"hit", "spear-attack",
		"miss", "spear-miss"
	}
} )

DefineUnitType("unit-peon", { Name = _("Fawn"),
	Parent = "unit-peasant",
	Civilization = "wild",
	Description = _("Goblin workers do not live an enviable life. Those that have the opportunity seek to become warriors instead, a position in which they can obtain much better food and everyday commodities by raiding."),
	Image = {"file", "goblin/units/goblin_worker.png", "size", {72, 72}},
	Animations = "animations-gnomish-worker", Icon = "icon-goblin-worker",
	Corpse = "unit-goblin-dead-body",
	CanGatherResources = {
	 {"file-when-loaded", "goblin/units/goblin_worker_with_gold.png",
		"resource-id", "gold",
		"resource-capacity", 100,
		"resource-step", 2,
		"wait-at-resource", 3,
		"wait-at-depot", 150},
	 {"file-when-loaded", "goblin/units/goblin_worker_with_lumber.png",
		"resource-id", "lumber",
		"resource-capacity", 100,
		"resource-step", 2,
		"wait-at-resource", 24,
		"wait-at-depot", 150,}},
	Variations = {
		{
			"variation-id", "bald"
		},
		{
			"variation-id", "spiky-hair",
			"file", "goblin/units/goblin_worker_spiky_hair.png",
			"file-when-loaded", "gold", "goblin/units/goblin_worker_with_gold_spiky_hair.png",
			"file-when-loaded", "lumber", "goblin/units/goblin_worker_with_lumber_spiky_hair.png"
		}
	},
	Sounds = {
		"selected", "basic-goblin-voices-selected-group",
		"acknowledge", "basic-goblin-voices-acknowledge",
		"ready", "goblin-worker-ready",
--		"help", "basic-dwarf-voices-help",
		"dead", "basic-goblin-voices-dead",
		"hit", "mace-attack",
		"miss", "attack-miss"
	}
})

DefineUnitType("unit-skeleton", { Name = _("Skeleton"),
	Parent = "unit-footman",
	Civilization = "wild",
	Image = {"file", "germanic/units/worker.png", "size", {72, 72}},
	Animations = "animations-dwarven-miner", Icon = "icon-germanic-worker",
	Corpse = "unit-human-dead-body",
})

DefineUnitType("unit-catapult", { Name = _("Catapult"),
	Parent = "unit-ballista",
	Civilization = "wild",
	Description = _("These engines of war can be of great use in battering enemy fortifications."),
	Image = {"file", "teuton/units/catapult.png", "size", {72, 72}},
	Animations = "animations-teuton-catapult", Icon = "icon-teuton-catapult",
	Missile = "missile-catapult-flaming-rock",
	Sounds = {
		"selected", "click",
		"dead", "explosion"
	}
})

DefineUnitType("unit-ogre", { Name = _("Ogre"),
	Parent = "unit-dwarven-yale-rider",
	Civilization = "wild",
	Image = {"file", "dwarf/units/yale_rider_red_hair_gray_fur.png", "size", {72, 72}},
	Animations = "animations-melee-unit", Icon = "icon-dwarven-steelclad",
	StartingLevel = 2,
	Corpse = "unit-dwarven-dead-body",
	Excrement = "unit-yale-excrement",
})

DefineUnitType("unit-ogre-mage", { Name = _("Ogre Mage"),
	Parent = "unit-knight",
	Civilization = "wild",
	Image = {"file", "dwarf/units/yale_rider_red_hair_gray_fur.png", "size", {72, 72}},
	Animations = "animations-melee-unit", Icon = "icon-dwarven-steelclad",
	StartingLevel = 2,
	Corpse = "unit-dwarven-dead-body",
	Excrement = "unit-yale-excrement",
})

DefineUnitType("unit-axethrower", { Name = _("Axethrower"),
	Parent = "unit-goblin-archer",
	Civilization = "wild",
	Description = _("Swift and deadly, the goblin archers hone above all the art of the ambush. Wary of being caught unprepared, they carry daggers with them, should an enemy get too close."),
	Image = {"file", "goblin/units/goblin_archer.png", "size", {72, 72}},
	Animations = "animations-goblin-archer", Icon = "icon-goblin-archer",
	HitPoints = 35,
	Accuracy = 12,
	Evasion = 12,
	Missile = "missile-goblin-arrow",
	Corpse = "unit-goblin-dead-body",
	Sounds = {
		"selected", "basic-goblin-voices-selected-group",
		"acknowledge", "basic-goblin-voices-acknowledge",
		"ready", "goblin-archer-ready",
--		"help", "basic-dwarf-voices-help",
		"dead", "basic-goblin-voices-dead",
		"hit", "dagger-attack",
		"miss", "attack-miss"
	}
})

DefineUnitType("unit-berserker", { Name = _("Berserker"),
	Parent = "unit-archer",
	Civilization = "wild",
	Description = _("Swift and deadly, the goblin archers hone above all the art of the ambush. Wary of being caught unprepared, they carry daggers with them, should an enemy get too close."),
	Image = {"file", "goblin/units/goblin_archer.png", "size", {72, 72}},
	Animations = "animations-goblin-archer", Icon = "icon-goblin-archer",
	HitPoints = 35,
	Accuracy = 12,
	Evasion = 12,
	Missile = "missile-goblin-arrow",
	Corpse = "unit-goblin-dead-body",
	Sounds = {
		"selected", "basic-goblin-voices-selected-group",
		"acknowledge", "basic-goblin-voices-acknowledge",
		"ready", "goblin-archer-ready",
--		"help", "basic-dwarf-voices-help",
		"dead", "basic-goblin-voices-dead",
		"hit", "dagger-attack",
		"miss", "attack-miss"
	}
})

DefineUnitType("unit-quick-blade", { Name = _("Hero"),
	Parent = "unit-goblin-spearman",
	Civilization = "wild",
	Image = {"file", "goblin/units/goblin_spearman.png", "size", {72, 72}},
	Description = _("Due to their small size, the goblin infantry soldiers use the spear as their weapon of choice, as with it they can target their enemies' vital points, relying less on their lackluster strength."),
	Animations = "animations-goblin-spearman", Icon = "icon-goblin-spearman",
	Costs = {"time", 60, "gold", 500, "lumber", 50},
	HitPoints = 50,
	BasicDamage = 6, -- reduced damage, since it has a bonus against mounted units
	Accuracy = 12,
	Evasion = 12,
	BonusAgainstMounted = 100,
	Corpse = "unit-goblin-dead-body",
	Sounds = {
		"selected", "basic-goblin-voices-selected-group",
		"acknowledge", "basic-goblin-voices-acknowledge",
		"ready", "goblin-impaler-ready",
--		"help", "basic-dwarf-voices-help",
		"dead", "basic-goblin-voices-dead",
		"hit", "spear-attack",
		"miss", "spear-miss"
	}
} )

DefineUnitType("unit-nomad", { Name = _("Nomad"),
	Parent = "unit-berserker",
	Civilization = "wild",
	Description = _("Swift and deadly, the goblin archers hone above all the art of the ambush. Wary of being caught unprepared, they carry daggers with them, should an enemy get too close."),
	Image = {"file", "goblin/units/goblin_archer.png", "size", {72, 72}},
	Animations = "animations-goblin-archer", Icon = "icon-goblin-archer",
	HitPoints = 35,
	Accuracy = 12,
	Evasion = 12,
	Missile = "missile-goblin-arrow",
	Corpse = "unit-goblin-dead-body",
	Sounds = {
		"selected", "basic-goblin-voices-selected-group",
		"acknowledge", "basic-goblin-voices-acknowledge",
		"ready", "goblin-archer-ready",
--		"help", "basic-dwarf-voices-help",
		"dead", "basic-goblin-voices-dead",
		"hit", "dagger-attack",
		"miss", "attack-miss"
	}
})

DefineUnitType("unit-death-knight", { Name = _("Death Knight"),
	Parent = "unit-gnomish-herbalist",
	Civilization = "wild",
	Image = {"file", "gnome/units/gnomish_herbalist.png", "size", {72, 72}},
	Animations = "animations-gnomish-herbalist", Icon = "icon-gnomish-herbalist",
	HitPoints = 35,
	Accuracy = 10,
	Evasion = 10,
	Corpse = "unit-gnomish-dead-body",
	CanCastSpell = {"spell-herbal-cure", "spell-portent"},
	AutoCastActive = {"spell-herbal-cure"},
})

DefineUnitType("unit-goblin-sappers", { Name = _("Goblin"),
	Parent = "unit-dwarven-steelclad",
	Civilization = "wild",
	Image = {"file", "dwarf/units/dwarven_steelclad.png", "size", {72, 72}},
	Animations = "animations-dwarven-axefighter", Icon = "icon-dwarven-steelclad",
	Armor = 4,
})

-- Ground Heroes

DefineUnitType("unit-caanoo-wiseskeleton", { Name = "Wise Skeleton",
	Parent = "unit-gnomish-herbalist",
	Civilization = "wild",
	Image = {"file", "gnome/units/gnomish_herbalist.png", "size", {72, 72}},
	Animations = "animations-gnomish-herbalist", Icon = "icon-gnomish-herbalist",
	Costs = {"time", 120, "gold", 1200},
	Speed = 8,
	HitPoints = 60,
	DrawLevel = 40,
	Mana = {Enable = false},
	TileSize = {1, 1}, BoxSize = {33, 33},
	SightRange = 9, ComputerReactionRange = 11, PersonReactionRange = 9,
	BasicDamage = 0, PiercingDamage = 9, Missile = "missile-lightning",
	MaxAttackRange = 2,
	Priority = 70,
	Points = 100,
	Demand = 1,
	Type = "land",
	RightMouseAction = "attack",
	CanAttack = true,
	CanTargetLand = true, CanTargetSea = true, CanTargetAir = true,
	CanCastSpell = {
		"spell-unit-footman",
		"spell-unit-archer",
		"spell-unit-ballista",
		"spell-unit-knight",
		"spell-unit-female-hero",
		"spell-unit-knight-rider",
		"spell-unit-peasant",
		"spell-unit-ranger",
		"spell-unit-yeoman",
		"spell-unit-gryphon-rider",
		"spell-unit-fad-man",
		"spell-unit-arthor-literios",
		"spell-unit-sharp-axe",
		"spell-unit-mage",
		"spell-unit-paladin",
		"spell-unit-attack-peasant",
		"spell-unit-dwarves"},
	LandUnit = true,
	Coward = true,
	organic = true,
	SelectableByRectangle = true,
})

DefineUnitType("unit-sharp-axe", { Name = _("Sharp Axe"),
	Parent = "unit-archer",
	Civilization = "wild",
	Image = {"file", "germanic/units/archer.png", "size", {72, 72}},
	Animations = "animations-goblin-archer", Icon = "icon-germanic-archer",
	Missile = "missile-arrow",
	Corpse = "unit-human-dead-body",
	TechnologyPointCost = 1,
})

DefineUnitType("unit-evil-knight", { Name = _("Evil Knight"),
	Parent = "unit-archer",
	Civilization = "wild",
	Image = {"file", "gnome/units/gnomish_herbalist.png", "size", {72, 72}},
	Animations = "animations-gnomish-herbalist", Icon = "icon-gnomish-herbalist",
	HitPoints = 35,
	Accuracy = 10,
	Evasion = 10,
	Corpse = "unit-gnomish-dead-body",
	CanCastSpell = {"spell-herbal-cure", "spell-portent"},
	AutoCastActive = {"spell-herbal-cure"},
})

DefineUnitType("unit-fad-man", { Name = _("Fad Man"),
	Parent = "unit-goblin-spearman",
	Civilization = "wild",
	Image = {"file", "goblin/units/goblin_spearman.png", "size", {72, 72}},
	Description = _("Due to their small size, the goblin infantry soldiers use the spear as their weapon of choice, as with it they can target their enemies' vital points, relying less on their lackluster strength."),
	Animations = "animations-goblin-spearman", Icon = "icon-goblin-spearman",
	Costs = {"time", 60, "gold", 500, "lumber", 50},
	HitPoints = 50,
	BasicDamage = 6, -- reduced damage, since it has a bonus against mounted units
	Accuracy = 12,
	Evasion = 12,
	BonusAgainstMounted = 100,
	Corpse = "unit-goblin-dead-body",
	Sounds = {
		"selected", "basic-goblin-voices-selected-group",
		"acknowledge", "basic-goblin-voices-acknowledge",
		"ready", "goblin-impaler-ready",
--		"help", "basic-dwarf-voices-help",
		"dead", "basic-goblin-voices-dead",
		"hit", "spear-attack",
		"miss", "spear-miss"
	}
} )

DefineUnitType("unit-beast-cry", { Name = _("Beast Cry"),
	Parent = "unit-archer",
	Civilization = "wild",
	Image = {"file", "gnome/units/gnomish_herbalist.png", "size", {72, 72}},
	Animations = "animations-gnomish-herbalist", Icon = "icon-gnomish-herbalist",
	HitPoints = 35,
	Accuracy = 10,
	Evasion = 10,
	Corpse = "unit-gnomish-dead-body",
	CanCastSpell = {"spell-herbal-cure", "spell-portent"},
	AutoCastActive = {"spell-herbal-cure"},
})

DefineUnitType("unit-ice-bringer", { Name = _("Ice Bringer"),
	Parent = "unit-archer",
	Civilization = "wild",
	Image = {"file", "gnome/units/gnomish_herbalist.png", "size", {72, 72}},
	Animations = "animations-gnomish-herbalist", Icon = "icon-gnomish-herbalist",
	HitPoints = 35,
	Accuracy = 10,
	Evasion = 10,
	Corpse = "unit-gnomish-dead-body",
	CanCastSpell = {"spell-herbal-cure", "spell-portent"},
	AutoCastActive = {"spell-herbal-cure"},
})

-- Air Units

DefineUnitType("unit-dragon", { Name = _("Dragon"),
	Parent = "unit-dwarven-gryphon-rider",
	Civilization = "wild",
	Image = {"file", "dwarf/units/gryphon_rider.png", "size", {100, 100}},
	DrawLevel = 45,
	Animations = "animations-dwarven-gryphon-rider", Icon = "icon-dwarven-gryphon-rider",
})

DefineUnitType("unit-zeppelin", { Name = _("Zeppelin"),
	Parent = "unit-dwarven-gryphon-rider",
	Civilization = "wild",
	Image = {"file", "dwarf/units/gryphon_rider.png", "size", {100, 100}},
	DrawLevel = 45,
	Animations = "animations-dwarven-gryphon-rider", Icon = "icon-dwarven-gryphon-rider",
})

-- Air Heroes

DefineUnitType("unit-fire-breeze", { Name = _("Fire Breeze"),
	Parent = "unit-gryphon-rider",
	Civilization = "wild",
	Image = {"file", "dwarf/units/gryphon_rider.png", "size", {100, 100}},
	DrawLevel = 45,
	Animations = "animations-dwarven-gryphon-rider", Icon = "icon-dwarven-gryphon-rider",
})

-- Sea Units

DefineUnitType("unit-human-oil-tanker", { Name = _("Oil tanker"),
	Parent = "unit-germanic-archer",
	--Civilization = "wild"
})

DefineUnitType("unit-human-transport", { Name = _("Transport"),
	Parent = "unit-germanic-archer",
	--Civilization = "wild"
})

DefineUnitType("unit-human-destroyer", { Name = _("Destroyer"),
	Parent = "unit-germanic-archer",
	--Civilization = "wild"
})

DefineUnitType("unit-battleship", { Name = _("Battleship"),
	Parent = "unit-germanic-archer",
	--Civilization = "wild"
})

DefineUnitType("unit-human-submarine", { Name = _("Submarine"),
	Parent = "unit-germanic-archer",
	--Civilization = "wild"
})

-- Buildings Land

DefineUnitType("unit-pig-farm", { Name = _("Farm"),
	Parent = "unit-farm",
	Civilization = "wild",
	Description = _("Goblin farms provide sustenance for their settlements. Contrary to the dwarves, goblins tend to plant roots, rather than mushrooms, and they also breed livestock."),
	Image = {"file", "goblin/buildings/farm.png", "size", {64, 64}},
	Icon = "icon-goblin-farm"
} )

DefineUnitType("unit-orc-barracks", { Name = _("Barracks"),
	Parent = "unit-human-barracks",
	Civilization = "wild",
	Description = _("Within mess halls goblin warriors gather to hone their skills and plan raids on nearby settlements."),
	Image = {"file", "goblin/buildings/mess_hall.png", "size", {96, 96}},
	Animations = "animations-building", Icon = "icon-goblin-mess-hall"
})

DefineUnitType("unit-ogre-mound", { Name = _("Ogre Mound"),
	Parent = "unit-stables",
	Civilization = "wild",
	Image = {"file", "germanic/buildings/barracks.png", "size", {96, 96}},
	Animations = "animations-building", Icon = "icon-germanic-barracks"
})

DefineUnitType("unit-orc-watch-tower", { Name = _("Watch Tower"),
	Parent = "unit-human-watch-tower",
	Civilization = "wild",
	Image = {"file", "germanic/buildings/farm.png", "size", {64, 64}},
	Icon = "icon-germanic-farm"
} )

DefineUnitType("unit-orc-guard-tower", { Name = _("Guard Tower"),
	Parent = "unit-human-guard-tower",
	Civilization = "wild",
	Image = {"file", "germanic/buildings/farm.png", "size", {64, 64}},
	Icon = "icon-germanic-farm"
} )

DefineUnitType("unit-orc-cannon-tower", { Name = _("Cannon Tower"),
	Parent = "unit-human-guard-tower",
	Civilization = "wild",
	Image = {"file", "germanic/buildings/farm.png", "size", {64, 64}},
	Icon = "icon-germanic-farm"
} )

DefineUnitType("unit-altar-of-storms", { Name = _("Altar of Storms"),
	Parent = "unit-church",
	Civilization = "wild",
	Image = {"file", "germanic/buildings/barracks.png", "size", {96, 96}},
	Animations = "animations-building", Icon = "icon-germanic-barracks"
})

DefineUnitType("unit-alchemist", { Name = _("Goblin Alchemist"),
	Parent = "unit-inventor",
	Civilization = "wild",
	Image = {"file", "germanic/buildings/barracks.png", "size", {96, 96}},
	Animations = "animations-building", Icon = "icon-germanic-barracks"
})

DefineUnitType("unit-dragon-roost", { Name = _("Dragon Roost"),
	Parent = "unit-gryphon-aviary",
	Civilization = "wild",
	Image = {"file", "germanic/buildings/barracks.png", "size", {96, 96}},
	Animations = "animations-building", Icon = "icon-germanic-barracks"
})

DefineUnitType("unit-troll-lumber-mill", { Name = _("Lumber Mill"),
	Parent = "unit-elven-lumber-mill",
	Civilization = "wild",
	Description = _("Although exhibiting a crude exterior, the goblin lumber mills carry saws as technologically advanced as that of other societies"),
	Image = {"file", "goblin/buildings/lumber_mill.png", "size", {96, 96}},
	Icon = "icon-goblin-lumber-mill"
})

DefineUnitType("unit-great-hall", { Name = _("Great Hall"),
	Parent = "unit-town-hall",
	Civilization = "wild",
	Description = _("The town hall is the center of a goblin settlement's life."),
	Image = {"file", "goblin/buildings/town_hall.png", "size", {128, 128}},
	Animations = "animations-building", Icon = "icon-goblin-town-hall"
})

DefineUnitType("unit-stronghold", { Name = _("Stronghold"),
	Parent = "unit-keep",
	Civilization = "wild",
	Description = _("The town hall is the center of a goblin settlement's life."),
	Image = {"file", "goblin/buildings/town_hall.png", "size", {128, 128}},
	Animations = "animations-building", Icon = "icon-goblin-town-hall"
})

DefineUnitType("unit-fortress", { Name = _("Fortress"),
	Parent = "unit-castle",
	Civilization = "wild",
	Description = _("The town hall is the center of a goblin settlement's life."),
	Image = {"file", "goblin/buildings/town_hall.png", "size", {128, 128}},
	Animations = "animations-building", Icon = "icon-goblin-town-hall"
})

DefineUnitType("unit-temple-of-the-damned", { Name = _("Temple of the Damned"),
	Parent = "unit-mage-tower",
	Civilization = "wild",
	Image = {"file", "germanic/buildings/town_hall.png", "size", {128, 128}},
	Animations = "animations-germanic-town-hall", Icon = "icon-germanic-town-hall",
	Construction = "construction-germanic-town-hall"
})

DefineUnitType("unit-orc-blacksmith", { Name = _("Blacksmith"),
	Parent = "unit-human-blacksmith",
	Civilization = "wild",
	Description = _("Goblins construct their forges out of the skulls of massive birds found on Nidavellir."),
	Background = _("The name 'Fugla' was taken from the Proto-Germanic language (the reconstructed ancestor to all Germanic languages), and means 'bird'."),
	Image = {"file", "goblin/buildings/smithy.png", "size", {96, 96}},
	Icon = "icon-goblin-smithy"
})

DefineUnitType("unit-orc-wall", { Name = _("Wall"),
	Parent = "unit-human-wall",
	Civilization = "wild",
	Image = {"file", "dwarf/units/dwarven_steelclad.png", "size", {72, 72}},
	Animations = "animations-dwarven-axefighter", Icon = "icon-dwarven-steelclad",
	Armor = 4,
})

-- Buildings Sea

DefineUnitType("unit-orc-shipyard", { Name = _("Shipyard"),
	Parent = "unit-germanic-archer",
	--Civilization = "wild"
})

DefineUnitType("unit-orc-foundry", { Name = _("Foundry"),
	Parent = "unit-germanic-archer",
	--Civilization = "wild"
})

DefineUnitType("unit-orc-refinery", { Name = _("Refinery"),
	Parent = "unit-germanic-archer",
	--Civilization = "wild"
})

DefineUnitType("unit-orc-oil-platform", { Name = _("Oil Platform"),
	Parent = "unit-germanic-archer",
	--Civilization = "wild"
})

-- Other

DefineUnitType("unit-orc-start-location", { Name = _("Start Location"),
	Parent = "unit-germanic-archer",
	--Civilization = "wild"
})

DefineAllow("unit-grunt", "AAAAAAAAAAAAAAAA")
DefineAllow("unit-peon", "AAAAAAAAAAAAAAAA")
DefineAllow("unit-skeleton", "AAAAAAAAAAAAAAAA")
DefineAllow("unit-catapult", "AAAAAAAAAAAAAAAA")
DefineAllow("unit-ogre", "AAAAAAAAAAAAAAAA")
DefineAllow("unit-ogre-mage", "AAAAAAAAAAAAAAAA")
DefineAllow("unit-axethrower", "AAAAAAAAAAAAAAAA")
DefineAllow("unit-berserker", "AAAAAAAAAAAAAAAA")
DefineAllow("unit-nomad", "AAAAAAAAAAAAAAAA")
DefineAllow("unit-death-knight", "AAAAAAAAAAAAAAAA")
DefineAllow("unit-goblin-sappers", "AAAAAAAAAAAAAAAA")
DefineAllow("unit-caanoo-wiseskeleton", "AAAAAAAAAAAAAAAA")
DefineAllow("unit-sharp-axe", "AAAAAAAAAAAAAAAA")
DefineAllow("unit-evil-knight", "AAAAAAAAAAAAAAAA")
DefineAllow("unit-fad-man", "AAAAAAAAAAAAAAAA")
DefineAllow("unit-beast-cry", "AAAAAAAAAAAAAAAA")
DefineAllow("unit-ice-bringer", "AAAAAAAAAAAAAAAA")
DefineAllow("unit-dragon", "AAAAAAAAAAAAAAAA")
DefineAllow("unit-zeppelin", "AAAAAAAAAAAAAAAA")
DefineAllow("unit-fire-breeze", "AAAAAAAAAAAAAAAA")
DefineAllow("unit-human-oil-tanker", "AAAAAAAAAAAAAAAA")
DefineAllow("unit-human-transport", "AAAAAAAAAAAAAAAA")
DefineAllow("unit-human-destroyer", "AAAAAAAAAAAAAAAA")
DefineAllow("unit-battleship", "AAAAAAAAAAAAAAAA")
DefineAllow("unit-human-submarine", "AAAAAAAAAAAAAAAA")
DefineAllow("unit-pig-farm", "AAAAAAAAAAAAAAAA")
DefineAllow("unit-orc-barracks", "AAAAAAAAAAAAAAAA")
DefineAllow("unit-ogre-mound", "AAAAAAAAAAAAAAAA")
DefineAllow("unit-orc-watch-tower", "AAAAAAAAAAAAAAAA")
DefineAllow("unit-orc-guard-tower", "AAAAAAAAAAAAAAAA")
DefineAllow("unit-orc-cannon-tower", "AAAAAAAAAAAAAAAA")
DefineAllow("unit-altar-of-storms", "AAAAAAAAAAAAAAAA")
DefineAllow("unit-alchemist", "AAAAAAAAAAAAAAAA")
DefineAllow("unit-dragon-roost", "AAAAAAAAAAAAAAAA")
DefineAllow("unit-troll-lumber-mill", "AAAAAAAAAAAAAAAA")
DefineAllow("unit-great-hall", "AAAAAAAAAAAAAAAA")
DefineAllow("unit-stronghold", "AAAAAAAAAAAAAAAA")
DefineAllow("unit-fortress", "AAAAAAAAAAAAAAAA")
DefineAllow("unit-temple-of-the-damned", "AAAAAAAAAAAAAAAA")
DefineAllow("unit-orc-blacksmith", "AAAAAAAAAAAAAAAA")
DefineAllow("unit-orc-wall", "AAAAAAAAAAAAAAAA")
DefineAllow("unit-human-shipyard", "AAAAAAAAAAAAAAAA")
DefineAllow("unit-human-foundry", "AAAAAAAAAAAAAAAA")
DefineAllow("unit-human-refinery", "AAAAAAAAAAAAAAAA")
DefineAllow("unit-human-oil-platform", "AAAAAAAAAAAAAAAA")